package addbk.js;

import java.awt.Color;
import java.beans.XMLEncoder;
import java.io.ByteArrayOutputStream;
import java.io.Serializable;

/**
 * Created by IntelliJ IDEA.
 * User: Subhash
 * Date: Mar 16, 2005
 * Time: 2:07:49 PM
 * To change this template use File | Settings | File Templates.
 */


/**
 * <!ELEMENT Address (
 * (title | firstName| lastName)*,
 * (streetAddress|address1 | address2| address3 )*,
 * (homePage | emailAddress)*,
 * (homePhone | businessPhone | faxPhone)*,
 * city,
 * state,
 * zip?)>
 */
// xml.adbk.Address
public class Address implements Comparable,
        Serializable {
    private String title = null;
    private String userId = null;
    private String password = null;
    private String firstName = null;
    private String lastName = null;
    private String street = null;
    private String company = null;
    private String address1 = null;
    private String address2 = null;
    private String address3 = null;
    private String homePage = null;
    private String emailAddress = null;
    private String homePhone = null;
    private String businessPhone = null;
    private String faxPhone = null;
    private String city = null;
    private String state = null;
    private String zip = null;
    private Color backGroundColor = null;

    public int compareTo(Object o1) {
        Address a = (Address) o1;
        String hisLastName = a.lastName.toLowerCase();
        String lastNameMine = getLastName().toLowerCase();
        return lastNameMine.compareTo(hisLastName);
    }

    public static void main(String args[]) {
        /*      sb.append(title + ",");
       sb.append(address1 + ",");
       sb.append(userId + ",");
       sb.append(password + ",");
       sb.append(firstName + ",");
       sb.append(lastName + ",");
       sb.append(street + ",");
       sb.append(city + ",");
       sb.append(state + ",");
       sb.append(zip);
       */
        Address a = new Address();
        a.setZip("066430");
        a.setLastName("Lyon");
        a.setCity("FFirfield");
        System.out.println("a=" + a);
    }

    public static Address getSample() {
        Address a = new Address();
        a.setAddress1("1313 Mocking bird lane");
        a.setCity("munsterville");
        a.setState("ny");
        a.setZip("12181");
        return a;
    }

    public String toString() {
        return this.toXml();
    }

    public Address() {
    }

    public Address(String s[]) {
        if (s.length == 8)
            setFirst8(s);
        if (s.length == 6)
            setFirst6(s);
    }

    public void setFirst8(String s[]) {
        //title,firstName,lastName,company, street, city, state, zip
        title = s[0];
        firstName = s[1];
        lastName = s[2];
        company = s[3];
        street = s[4];
        city = s[5];
        state = s[6];
        zip = s[7];
    }

    public void setFirst6(String s[]) {
        // lastName,streetAddress,address1,homePhone,businessPhone,faxPhone
        lastName = s[0];
        street = s[1];
        address1 = s[2];
        homePhone = s[3];
        businessPhone = s[4];
        faxPhone = s[5];
    }

    public void setAddress2(String s) {
        address2 = s;
    }

    public void setAddress3(String s) {
        address3 = s;
    }

    public void setEmailAddress(String s) {
        emailAddress = s;
    }

    public void setHomePhone(String s) {
        homePhone = s;
    }

    public void setHomePage(String s) {
        homePage = s;
    }

    public void setBusinessPhone(String s) {
        businessPhone = s;
    }

    public void setFaxPhone(String s) {
        faxPhone = s;
    }

    public void setCompany(String s) {
        company = s;
    }

    public void setAddress1(String s) {
        address1 = s;
    }

    public void setTitle(String s) {
        title = s;
    }

    public void setFirstName(String s) {
        firstName = s;
    }

    public void setLastName(String s) {
        lastName = s;
    }

    public void setUserId(String s) {
        userId = s;
    }

    public void setPassword(String s) {
        password = s;
    }

    public void setStreet(String s) {
        street = s;
    }

    public void setCity(String s) {
        city = s;
    }

    public void setState(String s) {
        state = s;
    }

    public boolean match(String ss) {
        String s = toCsv();
        return s.indexOf(ss) >= 0;
    }

    public void setZip(String s) {
        zip = s;
    }

    public String toHtml() {
        StringBuffer sb = new StringBuffer("");
        if (title != null)
            sb.append("\n\t<td>" + title + "</td>");
        if (company != null)
            sb.append("\n\t<td>" + company + "</td>");
        if (userId != null)
            sb.append("\n\t<td>" + userId + "</td>");
        if (password != null)
            sb.append("\n\t<td>" + password + "</td>");
        if (firstName != null)
            sb.append("\n\t<td>" + firstName + "</td>");
        if (lastName != null)
            sb.append("\n\t<td>" + lastName + "</td>");
        if (street != null)
            sb.append("\n\t<td>" + street + "</td>");
        if (city != null)
            sb.append("\n\t<td>" + city + "</td>");
        if (state != null)
            sb.append("\n\t<td>" + state + "</td>");
        if (zip != null)
            sb.append("\n\t<td>" + zip + "</td>\n");
        return "\n<tr>"
                + sb.toString()
                + "\n</tr>";
    }

    public String toCsv() {
        StringBuffer sb = new StringBuffer("");
        sb.append(title + ",");
        sb.append(address1 + ",");
        sb.append(userId + ",");
        sb.append(password + ",");
        sb.append(firstName + ",");
        sb.append(lastName + ",");
        sb.append(street + ",");
        sb.append(city + ",");
        sb.append(state + ",");
        sb.append(zip);
        return sb.toString() + "\n";
    }

    public String toXml() {
        ByteArrayOutputStream baos = new ByteArrayOutputStream();
        XMLEncoder e = new XMLEncoder(baos);
        e.writeObject(this);
        e.flush();
        return baos.toString();
    }

    public String toXmlOld() {
        StringBuffer sb = new StringBuffer("");
        if (title != null)
            sb.append("\n\t<title>" + title + "</title>");
        if (firstName != null)
            sb.append("\n\t<firstName>" + firstName + "</firstName>");
        if (lastName != null)
            sb.append("\n\t<lastName>" + lastName + "</lastName>");
        if (company != null)
            sb.append("\n\t<company>" + company + "</company>");
        if (address1 != null)
            sb.append("\n\t<address1>" + address1 + "</address1>");
        if (userId != null)
            sb.append("\n\t<userId>" + userId + "</userId>");
        if (password != null)
            sb.append("\n\t<password>" + password + "</password>");
        if (street != null)
            sb.append("\n\t<street>" + street + "</street>");
        if (city != null)
            sb.append("\n\t<city>" + city + "</city>");
        if (state != null)
            sb.append("\n\t<state>" + state + "</state>");
        if (zip != null)
            sb.append("\n\t<zip>" + zip + "</zip>\n");
        if (homePage != null)
            sb.append("\n\t<homePage>" + homePage + "</homePage>");
        return "\n<Address>"
                + sb.toString()
                + "\n</Address>";
    }

    public String getTitle() {
        return title;
    }

    public String getUserId() {
        return userId;
    }

    public String getPassword() {
        return password;
    }

    public String getFirstName() {
        return firstName;
    }

    public String getLastName() {
        return lastName;
    }

    public String getStreet() {
        return street;
    }

    public String getCompany() {
        return company;
    }

    public String getAddress1() {
        return address1;
    }

    public String getAddress2() {
        return address2;
    }

    public String getAddress3() {
        return address3;
    }

    public String getHomePage() {
        return homePage;
    }

    public String getEmailAddress() {
        return emailAddress;
    }

    public String getHomePhone() {
        return homePhone;
    }

    public String getBusinessPhone() {
        return businessPhone;
    }

    public String getFaxPhone() {
        return faxPhone;
    }

    public String getCity() {
        return city;
    }

    public String getState() {
        return state;
    }

    public String getZip() {
        return zip;
    }

    public Color getBackGroundColor() {
        return backGroundColor;
    }

    public void setBackGroundColor(Color backGroundColor) {
        this.backGroundColor = backGroundColor;
    }
}