/*
 * Copyright (c) 2005 DocJava, Inc. All Rights Reserved.
 */
package addbk.midtermAddressBook;

import gui.run.RunButton;

import javax.swing.*;
import java.awt.*;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.beans.PropertyEditor;

public class AddressRecordEditor
        implements PropertyEditor {
    private AddressRecord addressRecord = new AddressRecord();

    JLabel firstNameLabel;
    JTextField firstNameTextField;
    JLabel lastNameLabel;
    JTextField lastNameTextField;
    JLabel address1Label;
    JTextField address1TextField;
    JLabel address2Label;
    JTextField address2TextField;
    JLabel phone1Label;
    JTextField phone1TextField;
    JLabel phone2Label;
    JTextField phone2TextField;
    JLabel phone3Label;
    JTextField phone3TextField;

    public boolean isPaintable() {
        return false;
    }

    public boolean supportsCustomEditor() {
        return true;
    }

    public JDialog display() {
        if (!(supportsCustomEditor())) return null;
        addPropertyChangeListener(new PropertyChangeListener() {
            public void propertyChange(PropertyChangeEvent evt) {
                addressRecord = (AddressRecord) evt.getNewValue();
            }
        });

        Component comp = getCustomEditor();
        JDialog jd = new JDialog();

        jd.setTitle("Address Book");
        jd.setResizable(false);
        jd.setModal(false);

        // Create menu bar and add it to the frame.
        JMenuBar menu = new JMenuBar();
        menu.setEnabled(true);
        menu.setVisible(true);
        jd.setJMenuBar(menu);
        Container c = jd.getContentPane();
        c.add(comp);
        jd.pack();
        jd.setVisible(true);
        return jd;
    }

    public Component getCustomEditor() {
        JPanel jp = new JPanel();
        jp.setPreferredSize(new Dimension(320, 210));

        firstNameLabel = new JLabel("First Name");
        firstNameTextField = new JTextField("", 20);
        lastNameLabel = new JLabel("Last Name");
        lastNameTextField = new JTextField("", 20);
        address1Label = new JLabel("Address1  ");
        address1TextField = new JTextField("", 20);
        address2Label = new JLabel("Address2  ");
        address2TextField = new JTextField("", 20);
        phone1Label = new JLabel("Phone1      ");
        phone1TextField = new JTextField("", 20);
        phone2Label = new JLabel("Phone2      ");
        phone2TextField = new JTextField("", 20);
        phone3Label = new JLabel("Phone3      ");
        phone3TextField = new JTextField("", 20);

        jp.add(firstNameLabel);
        jp.add(firstNameTextField);
        jp.add(lastNameLabel);
        jp.add(lastNameTextField);
        jp.add(address1Label);
        jp.add(address1TextField);
        jp.add(address2Label);
        jp.add(address2TextField);
        jp.add(phone1Label);
        jp.add(phone1TextField);
        jp.add(phone2Label);
        jp.add(phone2TextField);
        jp.add(phone3Label);
        jp.add(phone3TextField);

        jp.add(new RunButton("P[revious") {
            public void run() {
                AddressBookMediator abm = new AddressBookMediator();
                System.out.println("PREVIOUS!");
                addressRecord = fieldsToAdd();
                try {
                    AddressBookMediator.getAbc().saveCurrentRecord(addressRecord); // Save the current values
                } catch (ArrayIndexOutOfBoundsException e) {
                    addressRecord = fieldsToAdd(); // addressrecord is updated.
                    abm.addRecord(addressRecord);
                }

                AddressBookMediator.getAbc().decrementRecord();
                addressRecord = AddressBookMediator.getAbc().readRecord(); // Read the record at the current position.
                addRecToFields(); // Fill the addressRecord object with data.
            }
        });

        jp.add(new RunButton("Ne[xt") {
            public void run() {
                System.out.println("NEXT BUTTON!");
                AddressBookMediator abm = new AddressBookMediator();
                addressRecord = fieldsToAdd();
                try {
                    AddressBookMediator.getAbc().saveCurrentRecord(addressRecord); // Save the current values.
                } catch (ArrayIndexOutOfBoundsException e) {

                    addressRecord = fieldsToAdd(); // addressrecord is updated.
                    abm.addRecord(addressRecord);
                }

                // if there are additional records next, load it
                if (AddressBookMediator.getAbc().getNumRecords() >
                        AddressBookMediator.getAbc().getRecPosition()) {
                    AddressBookMediator.getAbc().incrementRecord();
                    addressRecord = AddressBookMediator.getAbc().readRecord(); // Read the record at the current position.
                    addRecToFields(); // Fill the addressRecord object with data.
                } // No additonal records.
                else {
                    addressRecord = fieldsToAdd(); // addressrecord is updated.
                    abm.addRecord(addressRecord); // New addressRecord object added.
                }
            }
        });


        jp.add(new RunButton("Ne[w") {
            public void run() {
                addbk.midtermAddressBook.AddressBookMediator abm = new addbk.midtermAddressBook.AddressBookMediator();
                addressRecord = fieldsToAdd(); // addressrecord is updated.
                abm.addRecord(addressRecord);
                System.out.println("NEW BUTTON!");
                AddressBookMediator.getAbc().incrementRecord();
                addressRecord = AddressBookMediator.getAbc().readRecord(); // Read the record at the current position.
                addRecToFields(); // Fill


                AddressBookMediator.getAbc().addRecord(AddressBookMediator.getAbc().getEmptyRecord());
                AddressBookMediator.getAbc().setRecordNumber(
                        AddressBookMediator.getAbc().getAddressVector().size() + 1);

                addressRecord = new AddressRecord(); // New AddressRecord
                addRecToFields();
            }
        });


        return jp;
    }

    //todo: get a record from a custom editor
    //Hint: a modal dialog might be good for this.
    private AddressRecord promptUserForAddressRecord() {
        return null;
    }

    /**
     * Fills in all the text fields from the addressrecord object
     */
    private void addRecToFields() {
        firstNameTextField.setText(addressRecord.getFirstName());
        lastNameTextField.setText(addressRecord.getLastName());
        address1TextField.setText(addressRecord.getAddress1());
        address2TextField.setText(addressRecord.getAddress2());
        phone1TextField.setText(addressRecord.getPhone1());
        phone2TextField.setText(addressRecord.getPhone2());
        phone3TextField.setText(addressRecord.getPhone3());
    }

    /**
     * Returns the addressRecord object according to the textfields'
     * values.
     */
    private AddressRecord fieldsToAdd() {
        AddressRecord ar = new AddressRecord();
        ar.setFirstName(firstNameTextField.getText());
        ar.setLastName(lastNameTextField.getText());
        ar.setAddress1(address1TextField.getText());
        ar.setAddress2(address2TextField.getText());
        ar.setPhone1(phone1TextField.getText());
        ar.setPhone2(phone2TextField.getText());
        ar.setPhone3(phone3TextField.getText());
        return ar;
    }

    public void addPropertyChangeListener(PropertyChangeListener listener) {
        addressRecord.addPropertyChangeListener(listener);
    }

    public void removePropertyChangeListener(
            PropertyChangeListener listener) {
        addressRecord.removePropertyChangeListener(listener);

    }

    public Object getValue() {
        return addressRecord;
    }

    /**
     * Sets the AddressRecord according to the given AddressRecord object
     */
    public void setValue(Object newValue) {
        AddressRecord newRecord = (AddressRecord) newValue;
        if (addressRecord.equals(newRecord)) return;

        addressRecord = newRecord;
        addressRecord.update(); // Update the properties.
    }

    // todo: implement a CSV output for the getter.
    public String getAsText() {
        return addressRecord.toString();
    }

    public String getJavaInitializationString() {
        return null;
    }

    public String[] getTags() {
        return new String[0];
    }

    // todo: implement a CSV input for the
    // setter.
    public void setAsText(String text) throws IllegalArgumentException {

    }

    public void paintValue(Graphics gfx, Rectangle box) {
    }

}
