package addbk.midtermAddressBook;

import addbk.midtermAddressBook.Global;
import futils.Futil;
import java.util.StringTokenizer;
import java.io.*;

public class CSVReader {
  static boolean isSwing = false;

  //static boolean isSwing = true;

  public AddressBookCollection CSVReader() {
    AddressBookCollection abc = new AddressBookCollection();
    try {
      BufferedReader br = getReader("Please select a CSV file.");
      for (String line = br.readLine(); line != null; line = br.readLine())
        abc.addRecord(getRecord(line));
      br.close();
    }
    catch (FileNotFoundException e) {
    e.printStackTrace();
    }
    catch (IOException e) {
    e.printStackTrace();
    }
    return abc;
  } // end constructor

  public static File getFile(String prompt) {
    if (isSwing)
      return Futil.JGetReadFile(prompt);
    return new File(
        Futil.getReadFileName(prompt));
  }

  public static BufferedReader getReader(
      String prompt) throws FileNotFoundException {
    return new BufferedReader(
        new InputStreamReader(
        new FileInputStream(
        getFile(prompt))));
  }

  /** Gets a comma separated line of values.
   *  Parses the string and creates a AddressRecord object. */
  private AddressRecord getRecord(String line) {

    AddressRecord ar = new AddressRecord();
    StringTokenizer st = new StringTokenizer(line, ",");
    try {
      ar.setFirstName(Global.removeEscChars(st.nextToken()));
      ar.setLastName(Global.removeEscChars(st.nextToken()));
      ar.setAddress1(Global.removeEscChars(st.nextToken()));
      ar.setAddress2(Global.removeEscChars(st.nextToken()));
      ar.setPhone1(Global.removeEscChars(st.nextToken()));
      ar.setPhone2(Global.removeEscChars(st.nextToken()));
      ar.setPhone3(Global.removeEscChars(st.nextToken()));
    }
    catch (Exception e) {
      e.printStackTrace();
    }
    return (ar);
  }

} // end CSVMerge
